info_christmann_recs3_tor_master_webinterface_components_flot_Flot = function() {
	var element = $(this.getElement());

	this.onStateChange = function() {
		var results = new Array();
		var series = this.getState().series;

		// Copy the two arrays "pointDates" and "pointValues" into an
		// array of arrays "points"
		for (var i = 0; i < series.length; i++) {
			if (series[i].points == null) {
				series[i].points = new Array();
			}
			for (var j = 0; j < series[i].pointTimes.length; j++) {
				series[i].points.push(new Array(series[i].pointTimes[j], series[i].pointValues[j]));
			}
		    results.push({
			    label: series[i].name, 
			    data: series[i].points, 
			    color: series[i].color
			    });
		}
		
		var options = {
		    xaxis: {
		        min: this.getState().xAxis.min,
		        max: this.getState().xAxis.max,
		        ticks: this.getState().xAxis.ticks,
		        axisLabel: this.getState().xAxis.label,
		        mode: this.getState().xAxis.mode,
		        
			    tickSize: [5, "second"],
			    tickFormatter: function (v, axis) {
			        var date = new Date(v);
			 
			 		// TODO: Add timezone support
			        if (date.getSeconds() % 15 == 0) {
			            var hours = date.getHours() < 10 ? "0" + date.getHours() : date.getHours();
			            var minutes = date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes();
			            var seconds = date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds();
			 
			            return hours + ":" + minutes + ":" + seconds;
			        } else {
			            return "";
			        }
			    }
		    },
		    yaxis: {
		        min: this.getState().yAxis.min,
		        max: this.getState().yAxis.max,
		        ticks: this.getState().yAxis.ticks,
		        axisLabel: this.getState().yAxis.label,
		        mode: this.getState().yAxis.mode
		    },
		    legend: {
		    	position: this.getState().legend.position,
		    	sorted: "ascending"
		    },
		    series: {
		        lines: { show: true, fill: this.getState().isAreaChart },
		        points: { show: false, fill: false }
		    },
		    grid : {
		    	backgroundColor: this.getState().grid.backgroundColor,
		    	borderWidth: this.getState().grid.borderWidth
		    }
		};
		$.plot(element, results, options);
	}
}
