package org.vaadin.peter.buttongroup.client;

import org.vaadin.peter.buttongroup.ButtonGroup;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.Widget;
import com.vaadin.client.ComponentConnector;
import com.vaadin.client.ConnectorHierarchyChangeEvent;
import com.vaadin.client.communication.StateChangeEvent;
import com.vaadin.client.communication.StateChangeEvent.StateChangeHandler;
import com.vaadin.client.ui.AbstractComponentContainerConnector;
import com.vaadin.client.ui.VButton;
import com.vaadin.shared.ui.Connect;

@Connect(ButtonGroup.class)
public class ButtonGroupConnector extends AbstractComponentContainerConnector {
    private static final long serialVersionUID = -6059995980209242010L;

    private final StateChangeHandler stateChangeHandler = new StateChangeHandler() {
        private static final long serialVersionUID = 5710643542131593943L;

        @Override
        public void onStateChanged(StateChangeEvent stateChangeEvent) {
            getWidget().updateButtonCssClasses();
        }
    };

    @Override
    protected Widget createWidget() {
        return GWT.create(VButtonGroup.class);
    }

    @Override
    public VButtonGroup getWidget() {
        return (VButtonGroup) super.getWidget();
    }

    @Override
    public void onStateChanged(StateChangeEvent stateChangeEvent) {
        super.onStateChanged(stateChangeEvent);

        getWidget().updateButtonCssClasses();
    }

    @Override
    public void onConnectorHierarchyChange(ConnectorHierarchyChangeEvent event) {

        getWidget().removeAllButtons();

        for (ComponentConnector connector : getChildComponents()) {
            connector.addStateChangeHandler(stateChangeHandler);

            getWidget().addButton((VButton) connector.getWidget());
        }
    }

    @Override
    public void updateCaption(ComponentConnector connector) {
        // NOP
    }
}
